Index: EcnlProtoTool/trunk/tcc-0.9.27/il-gen.c
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.26/il-gen.c	(revision 321)
+++ EcnlProtoTool/trunk/tcc-0.9.27/il-gen.c	(revision 331)
@@ -18,17 +18,9 @@
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  */
-#ifdef TARGET_DEFS_ONLY
+
+#error this code has bit-rotted since 2003
 
 /* number of available registers */
 #define NB_REGS             3
-#define NB_ASM_REGS         8 // TODO:
-#define ELF_PAGE_SIZE  0x1000 // TODO:
-#define MAX_ALIGN           8 // TODO:
-#define R_DATA_32   R_386_32 // TODO:
-#define R_DATA_PTR  R_386_32 // TODO:
-#define R_JMP_SLOT  R_386_JMP_SLOT // TODO:
-#define R_COPY      R_386_COPY // TODO:
-#define ELF_START_ADDR 0x08048000 // TODO:
-#define EM_TCC_TARGET 0xFF // TODO:
 
 /* a register can belong to several classes. The classes must be
@@ -52,4 +44,10 @@
 };
 
+const int reg_classes[NB_REGS] = {
+    /* ST0 */ RC_ST | RC_ST0,
+    /* ST1 */ RC_ST | RC_ST1,
+    /* ST2 */ RC_ST,
+};
+
 /* return registers for function */
 #define REG_IRET REG_ST0 /* single word int return register */
@@ -58,9 +56,9 @@
 
 /* defined if function parameters must be evaluated in reverse order */
-//#define INVERT_FUNC_PARAMS
+/* #define INVERT_FUNC_PARAMS */
 
 /* defined if structures are passed as pointers. Otherwise structures
    are directly pushed on stack. */
-//#define FUNC_STRUCT_PARAM_AS_PTR
+/* #define FUNC_STRUCT_PARAM_AS_PTR */
 
 /* pointer size, in bytes */
@@ -82,24 +80,11 @@
 
 enum ILOPCodes {
-#define ENUM_ILOPCODES_DEF
 #define OP(name, str, n) IL_OP_ ## name = n,
 #include "il-opcodes.h"
 #undef OP
-#undef ENUM_ILOPCODES_DEF
 };
 
-/******************************************************/
-#else /* ! TARGET_DEFS_ONLY */
- /******************************************************/
-#include "tcc.h"
-
-const int reg_classes[NB_REGS] = {
-	/* ST0 */ RC_ST | RC_ST0,
-	/* ST1 */ RC_ST | RC_ST1,
-	/* ST2 */ RC_ST,
-};
-
 char *il_opcodes_str[] = {
-#define OP(name, str, n) /*[n] = */str,
+#define OP(name, str, n) [n] = str,
 #include "il-opcodes.h"
 #undef OP
@@ -115,9 +100,5 @@
 static void out_byte(int c)
 {
-    int ind1 = ind + 1;
-    if (ind1 > cur_text_section->data_allocated)
-        section_realloc(cur_text_section, ind1);
-    *(char *)(cur_text_section->data + ind) = c;
-    ind++;
+    *(char *)ind++ = c;
 }
 
@@ -219,11 +200,9 @@
     case VT_FUNC:
         s = sym_find((unsigned)t >> VT_STRUCT_SHIFT);
-        if (s == NULL)
-            break;
-        il_type_to_str(buf, buf_size, s->type.t, varstr);
+        il_type_to_str(buf, buf_size, s->t, varstr);
         pstrcat(buf, buf_size, "(");
         sa = s->next;
         while (sa != NULL) {
-            il_type_to_str(buf1, sizeof(buf1), sa->type.t, NULL);
+            il_type_to_str(buf1, sizeof(buf1), sa->t, NULL);
             pstrcat(buf, buf_size, buf1);
             sa = sa->next;
@@ -235,10 +214,8 @@
     case VT_PTR:
         s = sym_find((unsigned)t >> VT_STRUCT_SHIFT);
-        if (s == NULL)
-            break;
         pstrcpy(buf1, sizeof(buf1), "*");
         if (varstr)
             pstrcat(buf1, sizeof(buf1), varstr);
-        il_type_to_str(buf, buf_size, s->type.t, buf1);
+        il_type_to_str(buf, buf_size, s->t, buf1);
         goto no_var;
     }
@@ -250,5 +227,5 @@
 }
 
-#define Reloc void
+
 /* patch relocation entry with value 'val' */
 void greloc_patch1(Reloc *p, int val)
@@ -285,5 +262,5 @@
     v = sv->r & VT_VALMASK;
     fc = sv->c.i;
-    ft = sv->type.t;
+    ft = sv->t;
 
     if (sv->r & VT_LVAL) {
@@ -364,5 +341,5 @@
     v = sv->r & VT_VALMASK;
     fc = sv->c.i;
-    ft = sv->type.t;
+    ft = sv->t;
     if (v == VT_LOCAL) {
         if (fc >= ARG_BASE) {
@@ -412,5 +389,5 @@
 void gfunc_param(GFuncContext *c)
 {
-    if ((vtop->type.t & VT_BTYPE) == VT_STRUCT) {
+    if ((vtop->t & VT_BTYPE) == VT_STRUCT) {
         tcc_error("structures passed as value not handled yet");
     } else {
@@ -429,10 +406,10 @@
     if ((vtop->r & (VT_VALMASK | VT_LVAL)) == VT_CONST) {
         /* XXX: more info needed from tcc */
-        il_type_to_str(buf, sizeof(buf), vtop->type.t, "xxx");
+        il_type_to_str(buf, sizeof(buf), vtop->t, "xxx");
         fprintf(il_outfile, " call %s\n", buf);
     } else {
         /* indirect call */
         gv(RC_INT);
-        il_type_to_str(buf, sizeof(buf), vtop->type.t, NULL);
+        il_type_to_str(buf, sizeof(buf), vtop->t, NULL);
         fprintf(il_outfile, " calli %s\n", buf);
     }
@@ -461,12 +438,12 @@
         
     sym = sym_find((unsigned)t >> VT_STRUCT_SHIFT);
-    if (sym == NULL)
-        return;
+    func_call = sym->r;
 
     addr = ARG_BASE;
     /* if the function returns a structure, then add an
        implicit pointer parameter */
-    func_vt = sym->type;
-    if ((func_vt.t & VT_BTYPE) == VT_STRUCT) {
+    func_vt = sym->t;
+    func_var = (sym->c == FUNC_ELLIPSIS);
+    if ((func_vt & VT_BTYPE) == VT_STRUCT) {
         func_vc = addr;
         addr++;
@@ -474,5 +451,5 @@
     /* define parameters */
     while ((sym = sym->next) != NULL) {
-        u = sym->type.t;
+        u = sym->t;
         sym_push(sym->v & ~SYM_FIELD, u,
                  VT_LOCAL | lvalue_type(sym->type.t), addr);
@@ -555,18 +532,4 @@
             gsym(vtop->c.i);
         }
-    } else {
-        if (is_float(vtop->type.t)) {
-            vpushi(0);
-            gen_op(TOK_NE);
-        }
-#define VT_FORWARD 0
-        if ((vtop->r & (VT_VALMASK | VT_LVAL | VT_FORWARD)) == VT_CONST) {
-            /* constant jmp optimization */
-            if ((vtop->c.i != 0) != inv) 
-                t = gjmp(t);
-        } else {
-            v = gv(RC_INT);
-            t = out_opj(IL_OP_BRTRUE - inv, t);
-        }
     }
     vtop--;
@@ -640,5 +603,5 @@
 
 /* generate a floating point operation 'v = t1 op t2' instruction. The
-   two operands are guaranted to have the same floating point type */
+   two operands are guaranteed to have the same floating point type */
 void gen_opf(int op)
 {
@@ -690,26 +653,5 @@
 }
 
-void ggoto(void) { }
-void gen_bounded_ptr_add(void) {}
-void gen_bounded_ptr_deref(int t) {}
-void gen_expr32(void) {}
-void asm_opcode(TCCState *s1, int opcode) {}
-void asm_compute_constraints(ASMOperand *operands,
-	int nb_operands, int nb_outputs,
-	const uint8_t *clobber_regs,
-	int *pout_reg) {}
-void subst_asm_operand(CString *add_str,
-	SValue *sv, int modifier) {}
-void asm_gen_code(ASMOperand *operands, int nb_operands,
-	int nb_outputs, int is_output,
-	uint8_t *clobber_regs,
-	int out_reg) {}
-void asm_clobber(uint8_t *clobber_regs, const char *str) {}
-void gen_le32(int c) {}
-void g(int c) {}
-void gen_le16(int v) {}
-
 /* end of CIL code generator */
 /*************************************************************/
-#endif
-/*************************************************************/
+
Index: EcnlProtoTool/trunk/tcc-0.9.27/il-opcodes.h
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.26/il-opcodes.h	(revision 321)
+++ EcnlProtoTool/trunk/tcc-0.9.27/il-opcodes.h	(revision 331)
@@ -138,7 +138,4 @@
 OP(CONV_R_UN, "conv.r.un", 0x76)
 OP(ANN_DATA_S, "ann.data.s", 0x77)
-#ifndef ENUM_ILOPCODES_DEF
-OP(0, NULL, 0x78)
-#endif
 OP(UNBOX, "unbox", 0x79)
 OP(THROW, "throw", 0x7a)
@@ -183,22 +180,4 @@
 OP(STELEM_R8, "stelem.r8", 0xa1)
 OP(STELEM_REF, "stelem.ref", 0xa2)
-#ifndef ENUM_ILOPCODES_DEF
-OP(0, NULL, 0xa3)
-OP(0, NULL, 0xa4)
-OP(0, NULL, 0xa5)
-OP(0, NULL, 0xa6)
-OP(0, NULL, 0xa7)
-OP(0, NULL, 0xa8)
-OP(0, NULL, 0xa9)
-OP(0, NULL, 0xaa)
-OP(0, NULL, 0xab)
-OP(0, NULL, 0xac)
-OP(0, NULL, 0xad)
-OP(0, NULL, 0xae)
-OP(0, NULL, 0xaf)
-OP(0, NULL, 0xb0)
-OP(0, NULL, 0xb1)
-OP(0, NULL, 0xb2)
-#endif
 OP(CONV_OVF_I1, "conv.ovf.i1", 0xb3)
 OP(CONV_OVF_U1, "conv.ovf.u1", 0xb4)
@@ -209,19 +188,6 @@
 OP(CONV_OVF_I8, "conv.ovf.i8", 0xb9)
 OP(CONV_OVF_U8, "conv.ovf.u8", 0xba)
-#ifndef ENUM_ILOPCODES_DEF
-OP(0, NULL, 0xbb)
-OP(0, NULL, 0xbc)
-OP(0, NULL, 0xbd)
-OP(0, NULL, 0xbe)
-OP(0, NULL, 0xbf)
-OP(0, NULL, 0xc0)
-OP(0, NULL, 0xc1)
-#endif
 OP(REFANYVAL, "refanyval", 0xc2)
 OP(CKFINITE, "ckfinite", 0xc3)
-#ifndef ENUM_ILOPCODES_DEF
-OP(0, NULL, 0xc4)
-OP(0, NULL, 0xc5)
-#endif
 OP(MKREFANY, "mkrefany", 0xc6)
 OP(ANN_CALL, "ann.call", 0xc7)
@@ -251,37 +217,4 @@
 OP(STIND_I, "stind.i", 0xdf)
 OP(CONV_U, "conv.u", 0xe0)
-#ifndef ENUM_ILOPCODES_DEF
-OP(0, NULL, 0xe1)
-OP(0, NULL, 0xe2)
-OP(0, NULL, 0xe3)
-OP(0, NULL, 0xe4)
-OP(0, NULL, 0xe5)
-OP(0, NULL, 0xe6)
-OP(0, NULL, 0xe7)
-OP(0, NULL, 0xe8)
-OP(0, NULL, 0xe9)
-OP(0, NULL, 0xea)
-OP(0, NULL, 0xeb)
-OP(0, NULL, 0xec)
-OP(0, NULL, 0xed)
-OP(0, NULL, 0xee)
-OP(0, NULL, 0xef)
-OP(0, NULL, 0xf0)
-OP(0, NULL, 0xf1)
-OP(0, NULL, 0xf2)
-OP(0, NULL, 0xf3)
-OP(0, NULL, 0xf4)
-OP(0, NULL, 0xf5)
-OP(0, NULL, 0xf6)
-OP(0, NULL, 0xf7)
-OP(0, NULL, 0xf8)
-OP(0, NULL, 0xf9)
-OP(0, NULL, 0xfa)
-OP(0, NULL, 0xfb)
-OP(0, NULL, 0xfc)
-OP(0, NULL, 0xfd)
-OP(0, NULL, 0xfe)
-OP(0, NULL, 0xff)
-#endif
 
 /* prefix instructions. we use an opcode >= 256 to ease coding */
@@ -303,7 +236,4 @@
 OP(STLOC, "stloc", 0x10e)
 OP(LOCALLOC, "localloc", 0x10f)
-#ifndef ENUM_ILOPCODES_DEF
-OP(0, NULL, 0x110)
-#endif
 OP(ENDFILTER, "endfilter", 0x111)
 OP(UNALIGNED, "unaligned", 0x112)
@@ -316,15 +246,6 @@
 OP(ANN_REF, "ann.ref", 0x119)
 OP(RETHROW, "rethrow", 0x11a)
-#ifndef ENUM_ILOPCODES_DEF
-OP(0, NULL, 0x11b)
-#endif
 OP(SIZEOF, "sizeof", 0x11c)
 OP(REFANYTYPE, "refanytype", 0x11d)
-#ifndef ENUM_ILOPCODES_DEF
-OP(0, NULL, 0x11e)
-OP(0, NULL, 0x11f)
-OP(0, NULL, 0x120)
-OP(0, NULL, 0x121)
-#endif
 OP(ANN_DATA, "ann.data", 0x122)
 OP(ANN_ARG, "ann.arg", 0x123)
Index: EcnlProtoTool/trunk/tcc-0.9.27/include/float.h
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.26/include/float.h	(revision 321)
+++ EcnlProtoTool/trunk/tcc-0.9.27/include/float.h	(revision 331)
@@ -28,5 +28,5 @@
 
 /* horrible intel long double */
-#ifdef __i386__
+#if defined __i386__ || defined __x86_64__
 
 #define LDBL_MANT_DIG 64
Index: EcnlProtoTool/trunk/tcc-0.9.27/include/stdarg.h
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.26/include/stdarg.h	(revision 321)
+++ EcnlProtoTool/trunk/tcc-0.9.27/include/stdarg.h	(revision 331)
@@ -5,24 +5,62 @@
 #ifndef _WIN64
 
-typedef void *va_list;
+//This should be in sync with the declaration on our lib/libtcc1.c
+/* GCC compatible definition of va_list. */
+typedef struct {
+    unsigned int gp_offset;
+    unsigned int fp_offset;
+    union {
+        unsigned int overflow_offset;
+        char *overflow_arg_area;
+    };
+    char *reg_save_area;
+} __va_list_struct;
 
-va_list __va_start(void *fp);
-void *__va_arg(va_list ap, int arg_type, int size);
-va_list __va_copy(va_list src);
-void __va_end(va_list ap);
+typedef __va_list_struct va_list[1];
 
-#define va_start(ap, last) ((ap) = __va_start(__builtin_frame_address(0)))
+void __va_start(__va_list_struct *ap, void *fp);
+void *__va_arg(__va_list_struct *ap, int arg_type, int size, int align);
+
+#define va_start(ap, last) __va_start(ap, __builtin_frame_address(0))
 #define va_arg(ap, type)                                                \
-    (*(type *)(__va_arg(ap, __builtin_va_arg_types(type), sizeof(type))))
-#define va_copy(dest, src) ((dest) = __va_copy(src))
-#define va_end(ap) __va_end(ap)
+    (*(type *)(__va_arg(ap, __builtin_va_arg_types(type), sizeof(type), __alignof__(type))))
+#define va_copy(dest, src) (*(dest) = *(src))
+#define va_end(ap)
+
+/* avoid conflicting definition for va_list on Macs. */
+#define _VA_LIST_T
 
 #else /* _WIN64 */
 typedef char *va_list;
-#define va_start(ap,last) ap = ((char *)&(last)) + ((sizeof(last)+7)&~7)
-#define va_arg(ap,type) (ap += (sizeof(type)+7)&~7, *(type *)(ap - ((sizeof(type)+7)&~7)))
+#define va_start(ap,last) __builtin_va_start(ap,last)
+#define va_arg(ap, t) ((sizeof(t) > 8 || (sizeof(t) & (sizeof(t) - 1))) \
+	? **(t **)((ap += 8) - 8) : *(t  *)((ap += 8) - 8))
+#define va_copy(dest, src) ((dest) = (src))
+#define va_end(ap)
+#endif
+
+#elif __arm__
+typedef char *va_list;
+#define _tcc_alignof(type) ((int)&((struct {char c;type x;} *)0)->x)
+#define _tcc_align(addr,type) (((unsigned)addr + _tcc_alignof(type) - 1) \
+                               & ~(_tcc_alignof(type) - 1))
+#define va_start(ap,last) ap = ((char *)&(last)) + ((sizeof(last)+3)&~3)
+#define va_arg(ap,type) (ap = (void *) ((_tcc_align(ap,type)+sizeof(type)+3) \
+                        &~3), *(type *)(ap - ((sizeof(type)+3)&~3)))
 #define va_copy(dest, src) (dest) = (src)
 #define va_end(ap)
-#endif
+
+#elif defined(__aarch64__)
+typedef struct {
+    void *__stack;
+    void *__gr_top;
+    void *__vr_top;
+    int   __gr_offs;
+    int   __vr_offs;
+} va_list;
+#define va_start(ap, last) __va_start(ap, last)
+#define va_arg(ap, type) __va_arg(ap, type)
+#define va_end(ap)
+#define va_copy(dest, src) ((dest) = (src))
 
 #else /* __i386__ */
Index: EcnlProtoTool/trunk/tcc-0.9.27/include/stdbool.h
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.26/include/stdbool.h	(revision 321)
+++ EcnlProtoTool/trunk/tcc-0.9.27/include/stdbool.h	(revision 331)
@@ -7,4 +7,5 @@
 #define true	1
 #define false	0
+#define __bool_true_false_are_defined 1
 
 #endif /* _STDBOOL_H */
Index: EcnlProtoTool/trunk/tcc-0.9.27/include/stddef.h
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.26/include/stddef.h	(revision 321)
+++ EcnlProtoTool/trunk/tcc-0.9.27/include/stddef.h	(revision 331)
@@ -14,12 +14,23 @@
 typedef signed short int int16_t;
 typedef signed int int32_t;
+#ifdef __LP64__
+typedef signed long int int64_t;
+#else
 typedef signed long long int int64_t;
+#endif
 typedef unsigned char uint8_t;
 typedef unsigned short int uint16_t;
 typedef unsigned int uint32_t;
+#ifdef __LP64__
+typedef unsigned long int uint64_t;
+#else
 typedef unsigned long long int uint64_t;
 #endif
+#endif
 
+#ifndef NULL
 #define NULL ((void*)0)
+#endif
+
 #define offsetof(type, field) ((size_t)&((type *)0)->field)
 
@@ -27,2 +38,17 @@
 
 #endif
+
+/* Older glibc require a wint_t from <stddef.h> (when requested
+   by __need_wint_t, as otherwise stddef.h isn't allowed to
+   define this type).   Note that this must be outside the normal
+   _STDDEF_H guard, so that it works even when we've included the file
+   already (without requiring wint_t).  Some other libs define _WINT_T
+   if they've already provided that type, so we can use that as guard.
+   TCC defines __WINT_TYPE__ for us.  */
+#if defined (__need_wint_t)
+#ifndef _WINT_T
+#define _WINT_T
+typedef __WINT_TYPE__ wint_t;
+#endif
+#undef __need_wint_t
+#endif
Index: EcnlProtoTool/trunk/tcc-0.9.27/lib/Makefile
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.26/lib/Makefile	(revision 321)
+++ EcnlProtoTool/trunk/tcc-0.9.27/lib/Makefile	(revision 331)
@@ -5,98 +5,69 @@
 TOP = ..
 include $(TOP)/Makefile
-VPATH = $(top_srcdir)/lib $(top_srcdir)/win32/lib
+VPATH = $(TOPSRC)/lib $(TOPSRC)/win32/lib
+T = $(or $(CROSS_TARGET),$(NATIVE_TARGET),unknown)
+X = $(if $(CROSS_TARGET),$(CROSS_TARGET)-)
+BIN = $(TOP)/$(X)libtcc1.a
 
-ifndef TARGET
- ifdef CONFIG_WIN64
-  TARGET = x86_64-win32
- else
- ifdef CONFIG_WIN32
-  TARGET = i386-win32
- else
- ifeq ($(ARCH),i386)
-  TARGET = i386
-  ifneq ($(TARGETOS),Darwin)
-   XCC = $(CC)
-  endif
- else
- ifeq ($(ARCH),x86-64)
-  TARGET = x86_64
-  ifneq ($(TARGETOS),Darwin)
-   XCC = $(CC)
-  endif
- endif
- endif
- endif
- endif
- BCHECK_O = bcheck.o
+XTCC ?= $(TOP)/$(X)tcc$(EXESUF)
+XCC = $(XTCC)
+XAR = $(XTCC) -ar
+XFLAGS-unx = -B$(TOPSRC)
+XFLAGS-win = -B$(TOPSRC)/win32 -I$(TOPSRC)/include
+XFLAGS = $(XFLAGS$(XCFG))
+XCFG = $(or $(findstring -win,$T),-unx)
+
+# in order to use gcc, tyoe: make <target>-libtcc1-usegcc=yes
+arm-libtcc1-usegcc ?= no
+
+ifeq "$($(T)-libtcc1-usegcc)" "yes"
+ XCC = $(CC)
+ XAR = $(AR)
+ XFLAGS = $(CFLAGS) -fPIC
 endif
 
-DIR = $(TARGET)
+# only for native compiler
+$(X)BCHECK_O = bcheck.o
 
-native : ../libtcc1.a
-cross : $(DIR)/libtcc1.a
-
-native : TCC = $(TOP)/tcc$(EXESUF)
-cross : TCC = $(TOP)/$(TARGET)-tcc$(EXESUF)
-
-I386_O = libtcc1.o alloca86.o alloca86-bt.o $(BCHECK_O)
-X86_64_O = libtcc1.o alloca86_64.o
-WIN32_O = $(I386_O) crt1.o wincrt1.o dllcrt1.o dllmain.o chkstk.o
-WIN64_O = $(X86_64_O) crt1.o wincrt1.o dllcrt1.o dllmain.o chkstk.o
-
-ifeq "$(TARGET)" "i386-win32"
- OBJ = $(addprefix $(DIR)/,$(WIN32_O))
- TGT = -DTCC_TARGET_I386 -DTCC_TARGET_PE
- XCC = $(TCC) -B$(top_srcdir)/win32 -I$(top_srcdir)/include
- XAR = $(DIR)/tiny_libmaker$(EXESUF)
-else
-ifeq "$(TARGET)" "x86_64-win32"
- OBJ = $(addprefix $(DIR)/,$(WIN64_O))
- TGT = -DTCC_TARGET_X86_64 -DTCC_TARGET_PE
- XCC = $(TCC) -B$(top_srcdir)/win32 -I$(top_srcdir)/include
- XAR = $(DIR)/tiny_libmaker$(EXESUF)
-else
-ifeq "$(TARGET)" "i386"
- OBJ = $(addprefix $(DIR)/,$(I386_O))
- TGT = -DTCC_TARGET_I386
- XCC ?= $(TCC) -B$(TOP)
-else
-ifeq "$(TARGET)" "x86_64"
- OBJ = $(addprefix $(DIR)/,$(X86_64_O))
- TGT = -DTCC_TARGET_X86_64
- XCC ?= $(TCC) -B$(TOP)
-else
- $(error libtcc1.a not supported on target '$(TARGET)')
-endif
-endif
-endif
-endif
-
-XFLAGS = $(CPPFLAGS) $(CFLAGS) $(TGT)
-
-ifeq ($(TARGETOS),Darwin)
- XAR = $(DIR)/tiny_libmaker$(EXESUF)
- XFLAGS += -D_ANSI_SOURCE
+ifeq ($(CONFIG_musl)$(CONFIG_uClibc),yes)
  BCHECK_O =
 endif
 
-ifdef XAR
-AR = $(XAR)
+ifdef CONFIG_OSX
+ XFLAGS += -D_ANSI_SOURCE
 endif
 
-$(DIR)/libtcc1.a ../libtcc1.a : $(OBJ) $(XAR)
-	$(AR) rcs $@ $(OBJ)
-$(DIR)/%.o : %.c
+I386_O = libtcc1.o alloca86.o alloca86-bt.o
+X86_64_O = libtcc1.o alloca86_64.o alloca86_64-bt.o
+ARM_O = libtcc1.o armeabi.o alloca-arm.o armflush.o
+ARM64_O = lib-arm64.o
+WIN_O = crt1.o crt1w.o wincrt1.o wincrt1w.o dllcrt1.o dllmain.o
+
+OBJ-i386 = $(I386_O) $(BCHECK_O)
+OBJ-x86_64 = $(X86_64_O) va_list.o $(BCHECK_O)
+OBJ-x86_64-osx = $(X86_64_O) va_list.o
+OBJ-i386-win32 = $(I386_O) chkstk.o bcheck.o $(WIN_O)
+OBJ-x86_64-win32 = $(X86_64_O) chkstk.o bcheck.o $(WIN_O)
+OBJ-arm64 = $(ARM64_O)
+OBJ-arm = $(ARM_O)
+OBJ-arm-fpa = $(ARM_O)
+OBJ-arm-fpa-ld = $(ARM_O)
+OBJ-arm-vfp = $(ARM_O)
+OBJ-arm-eabi = $(ARM_O)
+OBJ-arm-eabihf = $(ARM_O)
+OBJ-arm-wince = $(ARM_O) $(WIN_O)
+
+$(BIN) : $(patsubst %.o,$(X)%.o,$(OBJ-$T))
+	$(XAR) rcs $@ $^
+
+$(X)%.o : %.c
 	$(XCC) -c $< -o $@ $(XFLAGS)
-$(DIR)/%.o : %.S
+
+$(X)%.o : %.S
 	$(XCC) -c $< -o $@ $(XFLAGS)
-$(DIR)/%$(EXESUF) : $(TOP)/win32/tools/%.c
-	$(CC) -o $@ $< $(XFLAGS) $(LDFLAGS)
 
-$(OBJ) $(XAR) : $(DIR)/exists
-$(DIR)/exists :
-	mkdir -p $(DIR)
-	@echo $@ > $@
+$(X)crt1w.o : crt1.c
+$(X)wincrt1w.o : wincrt1.c
 
 clean :
-	rm -rfv i386-win32 x86_64-win32 i386 x86_64
+	rm -f *.a *.o $(BIN)
Index: EcnlProtoTool/trunk/tcc-0.9.27/lib/alloca-arm.S
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/lib/alloca-arm.S	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/lib/alloca-arm.S	(revision 331)
@@ -0,0 +1,17 @@
+	.text
+	.align	2
+	.global	alloca
+	.type	alloca, %function
+alloca:
+#ifdef __TINYC__
+        .int 0xe060d00d
+        .int 0xe3cdd007
+        .int 0xe1a0000d
+        .int 0xe1a0f00e
+#else
+	rsb	sp, r0, sp
+	bic	sp, sp, #7
+	mov	r0, sp
+	mov	pc, lr
+#endif
+	.size	alloca, .-alloca
Index: EcnlProtoTool/trunk/tcc-0.9.27/lib/alloca86-bt.S
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.26/lib/alloca86-bt.S	(revision 321)
+++ EcnlProtoTool/trunk/tcc-0.9.27/lib/alloca86-bt.S	(revision 331)
@@ -12,11 +12,11 @@
     jz      p6
 
-#ifdef TCC_TARGET_PE
+#ifdef _WIN32
 p4:
     cmp     $4096,%eax
-    jle     p5
+    jbe     p5
+    test    %eax,-4096(%esp)
     sub     $4096,%esp
     sub     $4096,%eax
-    test    %eax,(%esp)
     jmp p4
 
Index: EcnlProtoTool/trunk/tcc-0.9.27/lib/alloca86.S
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.26/lib/alloca86.S	(revision 321)
+++ EcnlProtoTool/trunk/tcc-0.9.27/lib/alloca86.S	(revision 331)
@@ -11,11 +11,11 @@
     jz      p3
 
-#ifdef TCC_TARGET_PE
+#ifdef _WIN32
 p1:
     cmp     $4096,%eax
-    jle     p2
+    jbe     p2
+    test    %eax,-4096(%esp)
     sub     $4096,%esp
     sub     $4096,%eax
-    test    %eax,(%esp)
     jmp p1
 p2:
@@ -29,7 +29,3 @@
     ret
 
-/* mark stack as nonexecutable */
-#if defined __ELF__ && defined __linux__
-    .section    .note.GNU-stack,"",@progbits
-#endif
 /* ---------------------------------------------- */
Index: EcnlProtoTool/trunk/tcc-0.9.27/lib/alloca86_64-bt.S
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.27/lib/alloca86_64-bt.S	(revision 331)
+++ EcnlProtoTool/trunk/tcc-0.9.27/lib/alloca86_64-bt.S	(revision 331)
@@ -0,0 +1,56 @@
+/* ---------------------------------------------- */
+/* alloca86_64.S */
+
+.globl __bound_alloca
+__bound_alloca:
+
+#ifdef _WIN32
+    # bound checking is not implemented
+    pop     %rdx
+    mov     %rcx,%rax
+    add     $15,%rax
+    and     $-16,%rax
+    jz      p3
+
+p1:
+    cmp     $4096,%rax
+    jbe     p2
+    test    %rax,-4096(%rsp)
+    sub     $4096,%rsp
+    sub     $4096,%rax
+    jmp p1
+p2:
+
+    sub     %rax,%rsp
+    mov     %rsp,%rax
+    add     $32,%rax
+
+p3:
+    push    %rdx
+    ret
+#else
+    pop     %rdx
+    mov     %rdi,%rax
+    mov     %rax,%rsi	# size, a second parm to the __bound_new_region
+
+    add     $15,%rax
+    and     $-16,%rax
+    jz      p3
+
+
+    sub     %rax,%rsp
+    mov     %rsp,%rdi	# pointer, a first parm to the __bound_new_region
+    mov     %rsp,%rax
+
+    push    %rdx
+    push    %rax
+    call   __bound_new_region
+    pop     %rax
+    pop     %rdx
+
+p3:
+    push    %rdx
+    ret
+#endif
+
+/* ---------------------------------------------- */
Index: EcnlProtoTool/trunk/tcc-0.9.27/lib/alloca86_64.S
===================================================================
--- EcnlProtoTool/trunk/tcc-0.9.26/lib/alloca86_64.S	(revision 321)
+++ EcnlProtoTool/trunk/tcc-0.9.27/lib/alloca86_64.S	(revision 331)
@@ -6,5 +6,5 @@
 alloca:
     pop     %rdx
-#ifdef TCC_TARGET_PE
+#ifdef _WIN32
     mov     %rcx,%rax
 #else
@@ -15,11 +15,11 @@
     jz      p3
 
-#ifdef TCC_TARGET_PE
+#ifdef _WIN32
 p1:
     cmp     $4096,%rax
-    jle     p2
+    jbe     p2
+    test    %rax,-4096(%rsp)
     sub     $4096,%rsp
     sub     $4096,%rax
-    test    %rax,(%rsp)
     jmp p1
 p2:
@@ -28,15 +28,7 @@
     sub     %rax,%rsp
     mov     %rsp,%rax
-#ifdef TCC_TARGET_PE
-    add     $32,%rax
-#endif
-
 p3:
     push    %rdx
     ret
 
-/* mark stack as nonexecutable */
-#if defined __ELF__ && defined __linux__
-    .section    .note.GNU-stack,"",@progbits
-#endif
 /* ---------------------------------------------- */
